CREATE DATABASE IF NOT EXISTS tournaments;
USE tournaments;

SET FOREIGN_KEY_CHECKS=0;

# RESET TABLES
DROP TABLE IF EXISTS TEAM;
DROP TABLE IF EXISTS TOURNAMENT;
DROP TABLE IF EXISTS ENCOUNTER;

DROP TABLE IF EXISTS TEAM_MEMBERSHIP;
DROP TABLE IF EXISTS TEAM_LEADERSHIP;
DROP TABLE IF EXISTS TEAM_LEADERSHIP_TOKEN;
DROP TABLE IF EXISTS PLAYER;

DROP TABLE IF EXISTS TOURNAMENT_API_TOKEN;
DROP TABLE IF EXISTS TOURNAMENT_PARTICIPATION;
DROP TABLE IF EXISTS TOURNAMENT_LEADERSHIP;
DROP TABLE IF EXISTS TOURNAMENT_LEADERSHIP_TOKEN;
DROP TABLE IF EXISTS ROUND_SCORE;
DROP TABLE IF EXISTS MATCHES;
DROP TABLE IF EXISTS MATCH_SCORE;
DROP TABLE IF EXISTS ENCOUNTER_PARTICIPATION;
DROP TABLE IF EXISTS ENCOUNTER;
DROP TABLE IF EXISTS STAGE_FREE_PASS;
DROP TABLE IF EXISTS GROUP_MEMBERSHIP;
DROP TABLE IF EXISTS GROUPS;
DROP TABLE IF EXISTS STAGE;
DROP TABLE IF EXISTS TOURNAMENT_PARAMETER;
DROP TABLE IF EXISTS TOURNAMENT_CLASSIFIER;
DROP TABLE IF EXISTS ADDITIONAL_SEASON_SCORE;

DROP TABLE IF EXISTS SEASON;

CREATE TABLE TOURNAMENT (
    TOURNAMENT_ID       INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    NAME                VARCHAR(100)    NOT NULL UNIQUE,
    CREATOR_UUID        VARCHAR(60)     NOT NULL,
    STATE               VARCHAR(20)     NOT NULL,
    CURRENT_STAGE_ID    INT UNSIGNED,
    FOREIGN KEY (CURRENT_STAGE_ID)      REFERENCES STAGE(STAGE_ID) ON DELETE SET NULL,
    CREATED_TSP         TIMESTAMP       NOT NULL DEFAULT NOW(),
    STARTED_TSP         TIMESTAMP       NULL,
    FINISHED_TSP        TIMESTAMP       NULL,
    SEASON_ID           INT UNSIGNED,
    FOREIGN KEY (SEASON_ID)             REFERENCES SEASON(SEASON_ID) ON DELETE SET NULL,
    TOURNAMENT_CLASSIFIER_ID                       INT UNSIGNED,
    FOREIGN KEY (TOURNAMENT_CLASSIFIER_ID)         REFERENCES TOURNAMENT_CLASSIFIER(TOURNAMENT_CLASSIFIER_ID) ON DELETE SET NULL
);

CREATE TABLE TOURNAMENT_CLASSIFIER (
    TOURNAMENT_CLASSIFIER_ID    INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    CLASSIFIER                  VARCHAR(10)     NOT NULL UNIQUE,
    DESCRIPTION                 VARCHAR(100)    NOT NULL DEFAULT ''
);

CREATE TABLE TOURNAMENT_PARAMETER (
    TOURNAMENT_PARAMETER_ID     INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    TOURNAMENT_ID               INT UNSIGNED    NOT NULL,
    FOREIGN KEY (TOURNAMENT_ID) REFERENCES      TOURNAMENT(TOURNAMENT_ID) ON DELETE CASCADE,
    PARAMETER_KEY              VARCHAR(50)     NOT NULL,
    PARAMETER_VALUE             VARCHAR(100)    NOT NULL
);

CREATE TABLE STAGE (
    STAGE_ID                        INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    TOURNAMENT_ID                   INT UNSIGNED    NOT NULL,
    FOREIGN KEY (TOURNAMENT_ID) REFERENCES  TOURNAMENT(TOURNAMENT_ID) ON DELETE CASCADE,
    STATE                           VARCHAR(20)     NOT NULL,
    TYPE                            VARCHAR(20)     NOT NULL,
    WINNING_TEAMS_PER_ENCOUNTER     INT UNSIGNED    NOT NULL DEFAULT 0
);

CREATE TABLE GROUPS (
    GROUP_ID            INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    STAGE_ID            INT UNSIGNED,
    FOREIGN KEY (STAGE_ID)  REFERENCES STAGE(STAGE_ID) ON DELETE CASCADE,
    NAME                VARCHAR(50)     NOT NULL,
    WINNING_TEAM_COUNT  INT UNSIGNED    NOT NULL DEFAULT 0
);

CREATE TABLE GROUP_MEMBERSHIP (
    GROUP_MEMBERSHIP_ID     INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    GROUP_ID                INT UNSIGNED    NOT NULL,
    FOREIGN KEY (GROUP_ID) REFERENCES  GROUPS(GROUP_ID) ON DELETE CASCADE,
    TEAM_ID                 INT UNSIGNED    NOT NULL,
    FOREIGN KEY (TEAM_ID) REFERENCES  TEAM(TEAM_ID) ON DELETE CASCADE,
    POINTS                  INT UNSIGNED    NOT NULL DEFAULT 0,
    ENCOUNTERS_WON          INT UNSIGNED    NOT NULL DEFAULT 0,
    MATCHES_WON             INT UNSIGNED    NOT NULL DEFAULT 0,
    ROUNDS_WON              INT UNSIGNED    NOT NULL DEFAULT 0,
    GROUP_WON               BOOLEAN         NOT NULL DEFAULT FALSE
);

CREATE TABLE STAGE_FREE_PASS (
    STAGE_FREE_PASS_ID   INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    STAGE_ID             INT UNSIGNED,
    FOREIGN KEY (STAGE_ID) REFERENCES  STAGE(STAGE_ID) ON DELETE CASCADE,
    TEAM_ID              INT UNSIGNED,
    FOREIGN KEY (TEAM_ID) REFERENCES  TEAM(TEAM_ID) ON DELETE CASCADE
);

CREATE TABLE ENCOUNTER (
    ENCOUNTER_ID            INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    STAGE_ID                INT UNSIGNED    NOT NULL,
    FOREIGN KEY (STAGE_ID) REFERENCES STAGE(STAGE_ID) ON DELETE CASCADE,
    STATE                   VARCHAR(20)     NOT NULL,
    HOSTER                  VARCHAR(60),
    CREATED_TSP             TIMESTAMP       NOT NULL DEFAULT NOW(),
    STARTED_TSP             TIMESTAMP,
    FINISHED_TSP            TIMESTAMP
);

CREATE TABLE MATCHES (
    MATCH_ID                INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    ENCOUNTER_ID            INT UNSIGNED    NOT NULL,
    FOREIGN KEY (ENCOUNTER_ID) REFERENCES ENCOUNTER(ENCOUNTER_ID) ON DELETE CASCADE
);

CREATE TABLE MATCH_SCORE (
    MATCH_SCORE_ID             INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    MATCH_ID                   INT UNSIGNED    NOT NULL,
    FOREIGN KEY (MATCH_ID) REFERENCES MATCHES(MATCH_ID) ON DELETE CASCADE,
    ENCOUNTER_PARTICIPATION_ID INT UNSIGNED    NOT NULL,
    FOREIGN KEY (ENCOUNTER_PARTICIPATION_ID) REFERENCES ENCOUNTER_PARTICIPATION(ENCOUNTER_PARTICIPATION_ID) ON DELETE CASCADE,
    ROUNDS_WON                 INT UNSIGNED    NOT NULL
);

CREATE TABLE TOURNAMENT_PARTICIPATION (
    TOURNAMENT_PARTICIPATION_ID  INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    TEAM_ID                      INT UNSIGNED    NOT NULL,
    FOREIGN KEY (TEAM_ID) REFERENCES TEAM(TEAM_ID) ON DELETE CASCADE,
    TOURNAMENT_ID                INT UNSIGNED    NOT NULL,
    FOREIGN KEY (TOURNAMENT_ID) REFERENCES TOURNAMENT(TOURNAMENT_ID) ON DELETE CASCADE,
    JOIN_TSP                     TIMESTAMP       NOT NULL DEFAULT NOW(),
    STATE                        VARCHAR(20)     NOT NULL,
    ELIGIBLE_TO_PLAY             BOOLEAN         NOT NULL DEFAULT FALSE,
    LOST_STAGE_ID                INT UNSIGNED,
    FOREIGN KEY (LOST_STAGE_ID) REFERENCES STAGE(STAGE_ID) ON DELETE CASCADE
);

CREATE TABLE TOURNAMENT_LEADERSHIP (
    TOURNAMENT_LEADERSHIP_ID    INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    TOURNAMENT_ID               INT UNSIGNED    NOT NULL,
    FOREIGN KEY (TOURNAMENT_ID) REFERENCES TOURNAMENT(TOURNAMENT_ID) ON DELETE CASCADE,
    UUID                        VARCHAR(60)     NOT NULL,
    BEGIN_TSP                   TIMESTAMP       NOT NULL DEFAULT NOW()
);

CREATE TABLE TOURNAMENT_LEADERSHIP_TOKEN (
    TOURNAMENT_LEADERSHIP_TOKEN_ID  INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    TOURNAMENT_ID                   INT UNSIGNED    NOT NULL,
    FOREIGN KEY (TOURNAMENT_ID) REFERENCES TOURNAMENT(TOURNAMENT_ID) ON DELETE CASCADE,
    TOKEN                           VARCHAR(60)     NOT NULL,
    CREATED_TSP                     TIMESTAMP       NOT NULL DEFAULT NOW()
);

CREATE TABLE ENCOUNTER_PARTICIPATION (
    ENCOUNTER_PARTICIPATION_ID  INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    ENCOUNTER_ID                INT UNSIGNED    NOT NULL,
    FOREIGN KEY (ENCOUNTER_ID) REFERENCES ENCOUNTER(ENCOUNTER_ID) ON DELETE CASCADE,
    TEAM_ID                     INT UNSIGNED    NOT NULL,
    FOREIGN KEY (TEAM_ID) REFERENCES TEAM(TEAM_ID) ON DELETE CASCADE,
    READY                       BOOLEAN         NOT NULL DEFAULT FALSE,
    ENCOUNTER_RESULT            INT UNSIGNED    NOT NULL DEFAULT 0,
    MATCHES_WON                 INT UNSIGNED    NOT NULL DEFAULT 0,
    ROUNDS_WON                  INT UNSIGNED    NOT NULL DEFAULT 0
);

CREATE TABLE TEAM (
    TEAM_ID         INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    NAME            VARCHAR(100)    NOT NULL UNIQUE,
    TAG             VARCHAR(8)      UNIQUE,
    CREATOR_UUID    VARCHAR(60)     NOT NULL,
    JOIN_TOKEN      VARCHAR(60)     NOT NULL,
    SINGLE_PLAYER   BOOLEAN         NOT NULL,
    DESCRIPTION     TEXT,
    LOGO_URL        TEXT
);

CREATE TABLE PLAYER (
    PLAYER_ID       INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    TS_UID          VARCHAR(60)     NOT NULL UNIQUE,
    NAME            VARCHAR(100),
    ALLOWED_TO_PLAY BOOLEAN         NOT NULL DEFAULT TRUE
);

CREATE TABLE TEAM_MEMBERSHIP (
    TEAM_MEMBERSHIP_ID  INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    TEAM_ID             INT UNSIGNED    NOT NULL,
    FOREIGN KEY (TEAM_ID) REFERENCES TEAM(TEAM_ID) ON DELETE CASCADE,
    PLAYER_ID           INT UNSIGNED    NOT NULL,
    FOREIGN KEY (PLAYER_ID) REFERENCES PLAYER(PLAYER_ID) ON DELETE CASCADE,
    JOIN_TSP            TIMESTAMP       NOT NULL DEFAULT NOW(),
    ACTIVE              BOOLEAN         NOT NULL DEFAULT TRUE
);

CREATE TABLE TEAM_LEADERSHIP (
    TEAM_LEADERSHIP_ID  INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    TEAM_ID             INT UNSIGNED    NOT NULL,
    FOREIGN KEY (TEAM_ID) REFERENCES TEAM(TEAM_ID) ON DELETE CASCADE,
    UUID                VARCHAR(60)     NOT NULL,
    BEGIN_TSP           TIMESTAMP       NOT NULL DEFAULT NOW()
);

CREATE TABLE TEAM_LEADERSHIP_TOKEN (
    TEAM_LEADERSHIP_TOKEN_ID    INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    TEAM_ID                     INT UNSIGNED    NOT NULL,
    FOREIGN KEY (TEAM_ID) REFERENCES TEAM(TEAM_ID) ON DELETE CASCADE,
    TOKEN                       VARCHAR(60)     NOT NULL,
    CREATED_TSP                 TIMESTAMP       NOT NULL DEFAULT NOW()
);

CREATE TABLE TOURNAMENT_API_TOKEN (
    TOKEN_ID        INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    CLIENT_UUID     VARCHAR(60)     NOT NULL UNIQUE,
    TOKEN           VARCHAR(60)     NOT NULL UNIQUE,
    CREATION_TSP    DATETIME        NOT NULL
);

CREATE TABLE SEASON (
    SEASON_ID       INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    NAME            VARCHAR(100)    NOT NULL UNIQUE,
    START           TIMESTAMP       NOT NULL,
    END             TIMESTAMP       NOT NULL
);

CREATE TABLE ADDITIONAL_SEASON_SCORE (
    ADDITIONAL_SEASON_SCORE_ID  INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    TEAM_ID                     INT UNSIGNED    NOT NULL,
    FOREIGN KEY (TEAM_ID) REFERENCES TEAM(TEAM_ID) ON DELETE CASCADE,
    REASON                      VARCHAR(100)    NOT NULL,
    AMOUNT                      INT UNSIGNED    NOT NULL
);

SET FOREIGN_KEY_CHECKS=1;
